/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is TsumegoDS, a Go program for DS.                           *
 *                                                                   *
 * https://sourceforge.net/projects/tsumegods for more informations  *
 *                                                                   *
 * Copyright 2011 by Florian DUTHEIL, (Tryss from KGS                *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include "clock.h"

void initClock(Clock * clock, int time, int periods, int byoyomi)
{
    clock->player = EMPTY;
    clock->isBByoYomi = 0;
    clock->isWByoYomi = 0;

    clock->mainTime = time;
    clock->byoYomi = byoyomi;
    clock->periods = periods;

    PA_VBLCounterStart(0);
    PA_VBLCounterPause(0);
    PA_VBLCounterStart(1);
    PA_VBLCounterPause(1);
}


void updateClock(Clock * clock)
{
    if ( (clock->mainTime - PA_VBLCounter[0]/60 >= 0) && (!clock->isBByoYomi) )
    {
        PA_OutputText(1,5,5, "Black : %d:%d    ",
                      (clock->mainTime - PA_VBLCounter[0]/60)/60,
                      (clock->mainTime - PA_VBLCounter[0]/60)%60);
    }
    else
    {
        if (clock->isBByoYomi > clock->periods)
        {
            PA_OutputText(1,5,5, "Black : TIME OVER !");
        }
        else
        {
            if (!clock->isBByoYomi)
            {
                PA_VBLCounterStart (0);
                clock->isBByoYomi = 1;
            }
            else
            {
                if (clock->byoYomi - PA_VBLCounter[0]/60 < 0)
                {
                    PA_VBLCounterStart (0);
                    (clock->isBByoYomi)++;
                }
            }
            PA_OutputText(1,5,5, "Black : %d:%d    x %d  ",
                          (clock->byoYomi - PA_VBLCounter[0]/60)/60,
                          (clock->byoYomi - PA_VBLCounter[0]/60)%60,
                          clock->periods - clock->isBByoYomi + 1);
        }
    }
    if ( (clock->mainTime - PA_VBLCounter[1]/60 >= 0) && (!clock->isWByoYomi))
    {
        PA_OutputText(1,5,10, "White : %d:%d    ",
                      (clock->mainTime - PA_VBLCounter[1]/60)/60,
                      (clock->mainTime - PA_VBLCounter[1]/60)%60);
    }
    else
    {
        if (clock->isWByoYomi > clock->periods)
        {
            PA_OutputText(1,5,10, "White : TIME OVER !");
        }
        else
        {
            if (!clock->isWByoYomi)
            {
                PA_VBLCounterStart (1);
                clock->isWByoYomi = 1;
            }
            else
            {
                if (clock->byoYomi - PA_VBLCounter[1]/60 < 0)
                {
                    PA_VBLCounterStart (1);
                    (clock->isWByoYomi)++;
                }
            }
            PA_OutputText(1,5,10, "White : %d:%d    x %d  ",
                          (clock->byoYomi - PA_VBLCounter[1]/60)/60,
                          (clock->byoYomi - PA_VBLCounter[1]/60)%60,
                          clock->periods - clock->isWByoYomi + 1);
        }
    }
}

void pauseClock( Clock * clock)
{
    PA_VBLCounterPause( clock->player == BLACK ? 0 : 1);
}

void unpauseClock( Clock * clock)
{
    PA_VBLCounterUnpause( clock->player == BLACK ? 0 : 1);
}

void startClock( Clock * clock, int player)
{
    clock->player = player;
    PA_VBLCounterUnpause( player == BLACK ? 0 : 1);
}

void flipClock(Clock * clock)
{
    clock->player = clock->player == BLACK? WHITE : BLACK;
    if (clock->isBByoYomi)
        PA_VBLCounterStart (0);
    if (clock->isWByoYomi)
        PA_VBLCounterStart (1);
    PA_VBLCounterPause( clock->player == BLACK? 1:0);
    PA_VBLCounterUnpause( clock->player == BLACK? 0:1);
}
