/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is TsumegoDS, a Go program for DS.                           *
 *                                                                   *
 * https://sourceforge.net/projects/tsumegods for more informations  *
 *                                                                   *
 * Copyright 2011 by Florian DUTHEIL, (Tryss from KGS                *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#ifndef CLOCK_H_INCLUDED
#define CLOCK_H_INCLUDED

#include <PA9.h>
#include "go.h"

typedef struct clock_t
{
    int player;
    int isBByoYomi;
    int isWByoYomi;

    int mainTime;
    int byoYomi;
    int periods;
} Clock;

void initClock(Clock * clock, int time, int periods, int byoyomi);
void updateClock(Clock * clock);

void pauseClock( Clock * clock);
void unpauseClock( Clock * clock);
void startClock( Clock * clock, int player);
void flipClock(Clock * clock);

#endif // CLOCK_H_INCLUDED
