/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is TsumegoDS, a Go program for DS.                           *
 *                                                                   *
 * https://sourceforge.net/projects/tsumegods for more informations  *
 *                                                                   *
 * Copyright 2011 by Florian DUTHEIL, (Tryss from KGS                *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#ifndef DRAWING_H_INCLUDED
#define DRAWING_H_INCLUDED

#include <PA9.h>
#include "all_gfx.h"
#include "go.h"

enum sprites
{
    Black,
    White,
    Black_T,
    White_T,
    Quit,
    List,
    Score,
    Save,
    Up,
    Down,
    Right,
    Left,
    Wrong,
    Ok
};

void initGraphics(void);
void drawStone(int x, int y, int color);
void drawCountPoint(int x, int y, int color);
void eraseStone(int x, int y);
void eraseAllStone(void);
void eraseAll(void);

void activePad(SGFTree * tree);
void drawReplayGameInterface(void);
void drawRecordGameInterface(void);
void drawTsumegoInterface(void);
void drawOkWrong(int ok);
void eraseInterface(void);

#endif // DRAWING_H_INCLUDED
