/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is TsumegoDS, a Go program for DS.                           *
 *                                                                   *
 * https://sourceforge.net/projects/tsumegods for more informations  *
 *                                                                   *
 * Copyright 2011 by Florian DUTHEIL, (Tryss from KGS                *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#include "navigateTree.h"

void treeForward(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->child)
        {
            tree->lastnode = tree->lastnode->child;
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeBack(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->parent)
        {
            tree->lastnode = tree->lastnode->parent;
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeUp(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->parent)
        {
            SGFNode * node = tree->lastnode->parent->child;
            if (node != tree->lastnode)
            {
                while (node->next != tree->lastnode)
                {
                    node = node->next;
                }
                tree->lastnode = node;
            }
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeDown(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->next)
        {
            tree->lastnode = tree->lastnode->next;
        }
    }
}
