#include "navigateTree.h"

void treeForward(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->child)
        {
            tree->lastnode = tree->lastnode->child;
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeBack(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->parent)
        {
            tree->lastnode = tree->lastnode->parent;
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeUp(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->parent)
        {
            SGFNode * node = tree->lastnode->parent->child;
            if (node != tree->lastnode)
            {
                while (node->next != tree->lastnode)
                {
                    node = node->next;
                }
                tree->lastnode = node;
            }
        }
    }
    else
        tree->lastnode = tree->root;
}

void treeDown(SGFTree *tree)
{
    if (tree->lastnode)
    {
        if (tree->lastnode->next)
        {
            tree->lastnode = tree->lastnode->next;
        }
    }
}
