/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *\
 * This is TsumegoDS, a Go program for DS.                           *
 *                                                                   *
 * https://sourceforge.net/projects/tsumegods for more informations  *
 *                                                                   *
 * Copyright 2011 by Florian DUTHEIL, (Tryss from KGS                *
 *                                                                   *
 * This program is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU General Public License as    *
 * published by the Free Software Foundation - version 3 or          *
 * (at your option) any later version.                               *
 *                                                                   *
 * This program is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     *
 * GNU General Public License in file COPYING for more details.      *
 *                                                                   *
 * You should have received a copy of the GNU General Public         *
 * License along with this program; if not, write to the Free        *
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,       *
 * Boston, MA 02111, USA.                                            *
\* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
#ifndef REPLAYGAME_H_INCLUDED
#define REPLAYGAME_H_INCLUDED

#include <PA9.h>
#include <sys/dir.h>
#include <sys/stat.h>
#include <fat.h>

#include "all_gfx.h"
#include "sgftree.h"
#include "navigateTree.h"
#include "go.h"
#include "drawing.h"

void writeInformations(Goban * goban);
void writeComment(SGFTree * tree);
void addMark(SGFTree * tree);

int countListGames( void );
void writeListGames( int offset );
void loadGameNumber(int number, SGFTree * tree);
int loadGame(SGFTree * tree);

void infosFromSgf(Infos * infos, SGFTree * tree);
void replayGame( SGFTree * tree);

#endif // REPLAYGAME_H_INCLUDED
